
/*--------------------------------------------------------------------------------------------------
La conversion de l'entre analogique AN0 est dclenche automatiquement par le TIMER3 
Lorsque la conversion est termine le convertisseur dclenche une demande d'interruption
la routine d'interruption  envoie les 8bits de poids forts du rsultat de la conversion  sur le port C
Le programme principal aprs l'appel des sous programmes d'initialisation excute une boucle infinie
------------------------------------------------------------------------------------------------------*/

#include "p33FJ16MC304.h"
#pragma config FWDTEN = OFF             // Watchdog timer enabled/disabled by user software (dsactiv)

//*************************************************************************************
//Liste des fonctions  (on peux utiliser  un fichier .h et #include... )
void init_portC(void);
void init_timer3(void);
void init_adc(void);
void init_int(void);
//************************************************************************************** 

//**************************************************************************************
//Le programme principal
int main(void)
		{
                init_timer3();  //appel de sous-programmes
		init_portC();
		init_adc();
		init_int();
		while(1)                    
			{//Boucle infinie qui ne fait rien...
                         //On y place le programme principal
			}
		}
//fin du_programme principal
//**************************************************************************************

//***************************************************************************************
//Routine de traitement de l'interruption ADC
void __attribute__((__interrupt__,__shadow__,__no__psv__)) _ADC1Interrupt(void)
                {unsigned  int a;
                 a = ADC1BUF0;                   //lecture AN0
                 a=a>>8;  			//dcalage  droite de huit bits
                 PORTC =a;			//envoi en sortie
                 asm("bclr IFS0,#13") ;         //ou IFS0bits.AD1IF = 0;
                                                // efface le bit indicateur d'interruption AD
                }
//fin de la routine
//***************************************************************************************

//***************************************************************************************
//Dfinition des fonctions (on peut les placer dans un autre fichier .c
void init_portC(void)
		{TRISC=0x0000;
		}
void init_timer3(void)
		{
		T3CON=0x8000;
		PR3=0x0100;
		}
void init_adc(void)
		{AD1PCFGL=0xFFFE;
		AD1CON2=0x0000;
		AD1CON3=0x010A;
		AD1CHS0=0x0000;
		AD1CON1=0x8244;
	       	}   	
void init_int(void)
		{asm("DISI #4");
                 asm("bclr IFS0,#13");    //IFS0bits.AD1IF = 0;   //autorisation int ADC
		 asm("bset IEC0,#13");    //IEC0bits.AD1IE = 1;   //autorisation int ADC
		}
//**************************************************************************************


