;Programme INT_ADC.S

;--------------------------------------------------------------------------------------------------------------------------------
;La conversion de l'entre analogique AN0 est dclenche automatiquement par le TIMER3 
;Lorsque la conversion est termine le convertisseur dclenche une demande d'interruption
;la routine d'interruption  envoie les 8bits de poids forts du rsultat de la conversion  sur le port C
;Le programme principal aprs l'appel des sous programmes d'initialisation excute une boucle infinie
;---------------------------------------------------------------------------------------------------------------------------------

;***** Dsactiver le watchdog**********
            .section __FWDT.sec,code
            .global __FWDT
__FWDT:     .pword 0xFF7F
;**************************************

		.global	__reset	            ;adresse 000000 de la mmoire programme  ( voir fichier 30F6014.gld  ) 
		.global	__ADC1Interrupt     ;adresse du vecteur d'interruption ADC ( voir fichier 30F6014.gld  ) 


		.section   .text            ;indique au  linker d'utiliser la mmoire programme pour la suite
;*************************************************************************************************
;   Le Programme principal
;*************************************************************************************************
__reset:
		mov     #0x800,W15          ;initialisation du pointeur de pile
		rcall   _init_timer3        ;sous-programme d'initialisation 
		rcall   _init_portC
		rcall   _init_adc
		rcall   _init_int
boucle:                             ; Le programme principal fonctionne en boucle infinie.
		nop                         ; ne fait rien mais prend 1 cycle (no operation)
		bra boucle                  ; 

;fin du_programme principal..........

;*********************************************
; Routine de traitement de l'interruption ADC
;*********************************************
__ADC1Interrupt:
		mov ADC1BUF0,W0         ;lecture AN0
		lsr W0,#8,W0			;dcalage  droite de huit bits 
		mov W0,PORTC			;envoi en sortie
		bclr IFS0,#13			;rinitialise l'indicateur d'interruption ADC
		RETFIE

;*******************************************
;    Les sous-programmes
;*******************************************   
_init_portC:
		clr TRISC
		return
_init_timer3:
		mov #0x8000,W0
		mov W0,T3CON
		mov #0x100,W0
		mov W0,PR3
		return
_init_adc:
		mov #0xfffe,W0
        and AD1PCFGL        ; mise  0 du bit 0  par un ET avec W0 (fffe)
		mov #0x010A,W0
		mov W0,AD1CON3
        mov #0x0000,W0
		mov W0,AD1CON2
		mov W0,AD1CHS0
		mov #0x8244,W0
		mov W0,AD1CON1
		return
_init_int:
        DISI #4
		bclr IFS0,#13
		bset IEC0,#13
		return
.end   						; fin du fichier


